-- init world
world = {}

-- dependecies
local blocks = {}
width, height, tilewidth, tileheight = 0,0,0,0

-- Local functions
local function parse_text_file(filename)
    if love.filesystem.exists(filename) then
        local currentLayer = "none"
        local string = ""
        local w,h,tw,th = 0,0,0,0

        for line in love.filesystem.lines(filename) do
            -- dimensions
            if line:sub(1,6) == "width=" then
                w = tostring(line:sub(7))
            elseif line:sub(1,7) == "height=" then
                h = tostring(line:sub(8))
            elseif line:sub(1,10) == "tilewidth=" then
                tw = tostring(line:sub(11))
            elseif line:sub(1,11) == "tileheight=" then
                th = tostring(line:sub(12))
            end

            if line:sub(1,5) == "type=" then
                currentLayer = "pt"
            end

            if currentLayer == "pt" then
                if tonumber(line:sub(1,1)) or tonumber(line:sub(2,2)) then
                    local t = {}
                    for s in (line .. ","):gmatch("([^,]*),") do
                        table.insert(t, tonumber(s))
                    end
                    table.insert(tileTable, t)
                end
            end
        end

        -- set variables
        width = tonumber(w)
        height = tonumber(h)
        tilewidth = tonumber(tw)
        tileheight = tonumber(th)
    else
        return "Map doesn't exist"
    end
end

local function add_block(x,y,w,h,type)
   	local block = {x=x, y=y, w=w, h=h, type=type}
    blocks[#blocks+1] = block
   	wrld:add(block, x,y,w,h)
end

-- MAIN FUNCTIONS

function world:load()
	-- Tiles
    tileTable = {}
    parse_text_file("maps/newwalljumps.txt")
    
    for rowIndex=1, #tileTable do
        local row = tileTable[rowIndex]
        for columnIndex=1, #row do
            local number = row[columnIndex]
            local x = (columnIndex-1)*tilewidth
            local y = (rowIndex-1)*tileheight
            if number == 1 then
                add_block(x, y, tilewidth, tileheight, "solid")
            end
            if number == 2 then
                add_block(x, y, tilewidth, tileheight, "finish")
            end
        end
    end

    print(width, height, tilewidth, tileheight)
    -- graphics
    simpleWood = love.graphics.newImage("img/simple_wood.png")
    love.graphics.setBackgroundColor(240,240,240)

    
    cam = gamera.new(0, 0, width*tileheight, height*tileheight)
    cam:setWorld(0, 0, width*tileheight, height*tileheight)
    cam:setWindow(0, 0, love.graphics.getWidth(), love.graphics.getHeight())
end

function world:update(dt)

end

function world:draw()
    for i=1, #blocks do
        local b = blocks[i]
        if b.type == "solid" then
            love.graphics.setColor(0,0,0)
            love.graphics.rectangle("fill", b.x,b.y,tilewidth,tileheight)
            if player.debug then
                love.graphics.setColor(255,255,255,128)
                love.graphics.rectangle("line", b.x,b.y,tilewidth,tileheight)
            end
        elseif b.type == "finish" then
            love.graphics.setColor(255,0,0)
            love.graphics.rectangle("fill", b.x,b.y,tilewidth,tileheight)
        end
    end
end